events.listen('recipes', function (e) {
//Upgraded Netherite
e.remove({ id: 'upgradednetherite:ultimate_upgraded_netherite_ingot' })
e.shaped(item.of('upgradednetherite:ultimate_upgraded_netherite_ingot', 1), [
  'ABC',
  'DEF',
  'HIJ'
], {
  A: 'upgradednetherite:gold_upgraded_netherite_ingot',
  B: 'upgradednetherite:fire_upgraded_netherite_ingot',
  C: 'upgradednetherite:water_upgraded_netherite_ingot',
  D: 'upgradednetherite:poison_upgraded_netherite_ingot',
  E: 'upgradednetherite:feather_upgraded_netherite_ingot',
  F: 'upgradednetherite:phantom_upgraded_netherite_ingot',
  H: 'upgradednetherite:wither_upgraded_netherite_ingot',
  I: 'upgradednetherite:ender_upgraded_netherite_ingot',
  J: 'upgradednetherite:corrupt_upgraded_netherite_ingot'
})
  /*--------------------------FORBIDEN ARCANUS--------------------------*/
  //Eternal Stella
  e.remove({ id: 'forbidden_arcanus:eternal_stella' })
  e.custom({
    "type": "bloodmagic:altar",
    "input": { "item": "forbidden_arcanus:xpetrified_orb" },
    "output": { "item": "forbidden_arcanus:eternal_stella", "count": 1 },
    "upgradeLevel": 4,
    "altarSyphon": 50000,
    "consumptionRate": 20,
    "drainRate": 10
  })
  //Mundabitur Dust
  e.remove({ id: 'forbidden_arcanus:mundabitur_dust' })
  e.shaped(item.of('forbidden_arcanus:mundabitur_dust', 1), [
    'ABC',
    'DEF',
    '   '
  ], {
    A: 'forbidden_arcanus:arcane_crystal_dust',
    B: 'minecraft:redstone',
    C: 'minecraft:blaze_powder',
    D: 'minecraft:bone_meal',
    E: 'minecraft:phantom_membrane',
    F: 'minecraft:gunpowder'
  })
  //Magical Farmland
  e.shaped(item.of('forbidden_arcanus:magical_farmland', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: 'eidolon:arcane_gold_ingot',
    B: 'forbidden_arcanus:mundabitur_dust',
    C: 'mysticalagradditions:insanium_farmland'
  })
  //Chain
  e.remove({ id:'forbidden_arcanus:iron_chain' })
  e.shaped(item.of('forbidden_arcanus:iron_chain', 3), [
    '   ',
    'ABA',
    '   '
  ], {
    A: 'minecraft:iron_nugget',
    B: 'minecraft:iron_ingot'
  })
  /*--------------------------RFTOOLS--------------------------*/
  //Machine Frame
  e.remove({ id: 'rftoolsbase:machine_frame' })
  e.shaped(item.of('rftoolsbase:machine_frame', 1), [
    'CAC',
    'ABA',
    'CAC'
  ], {
    A: 'rftoolsbase:machine_base',
    B: 'immersiveengineering:component_steel',
    C: 'undergarden:cloggrum_ingot'
  })
  /*--------------------------BLUE POWER--------------------------*/
  //Tungsten Carbide  
  e.custom({
    "type": "mekanism:metallurgic_infusing",
    "itemInput": { "ingredient": { "tag": "forge:ingots/tungsten" } },
    "infusionInput": { "amount": 20, "tag": "mekanism:carbon" },
    "output": { "item": "bluepower:tungsten_carbide" }
  })

  //Steel Block
  e.remove({ id: 'mapperbase:steel_block' })
  e.remove({ id: 'mapperbase:steel_block_from_blasting' })
  //remove
  e.remove({ id: 'bluepower:alloy_furnace/red_alloy_ingot' })
  e.remove({ id: 'bluepower:alloy_furnace/tungsten_carbide' })
  /*--------------------------The Undergarden--------------------------*/
  //Catalyst
  e.remove({ id: 'undergarden:catalyst' })
  e.shaped(item.of('undergarden:catalyst', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: '#forge:plates/electrum',
    B: '#forge:plates/iron',
    C: 'thermal:enderium_coin'
  })
  /*--------------------------Baubley Heart--------------------------*/
  e.remove({ id: 'bhc:heart_amulet' })
  e.shaped(item.of('bhc:heart_amulet', 1), [
    'SAS',
    'BCD',
    ' E '
  ], {
    A: 'bhc:red_heart_canister',
    B: 'bhc:yellow_heart_canister',
    C: 'astralsorcery:shifting_star',
    D: 'bhc:green_heart_canister',
    E: 'bhc:blue_heart_canister',
    S: '#forge:string'
  })
  /*--------------------------Industrial Foregoing--------------------------*/
  //Mahcine Frame Pity
  e.remove({ id: 'industrialforegoing:machine_frame_pity' })
  e.shaped(item.of('industrialforegoing:machine_frame_pity', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: 'minecraft:stripped_oak_wood',
    B: 'thermal:iron_gear',
    C: 'immersiveengineering:rs_engineering'
  })
  /*--------------------------KUBEJS--------------------------*/
  //Platinum
  e.shaped(item.of('kubejs:platinum_ingot', 1), [
    'AAA',
    'AAA',
    'AAA'
  ], {
    A: 'kubejs:platinum_nugget'
  })
  //Platinum Block
  e.shapeless(item.of('kubejs:platinum_nugget', 9), ['kubejs:platinum_ingot'])
  e.shaped(item.of('kubejs:platinum_block', 1), [
    'AAA',
    'AAA',
    'AAA'
  ], {
    A: 'kubejs:platinum_ingot'
  })
  e.shapeless(item.of('kubejs:platinum_ingot', 9), ['kubejs:platinum_block'])
  e.smelting('kubejs:platinum_ingot', 'janoeo:platinum_dust')
  e.blasting('kubejs:platinum_ingot', 'janoeo:platinum_dust')
  //Obsidian Ingot Block
  e.shapeless(item.of('forbidden_arcanus:obsidian_ingot', 9), ['kubejs:obsidian_ingot_block'])
  e.shaped(item.of('kubejs:obsidian_ingot_block', 1), [
    'AAA',
    'AAA',
    'AAA'
  ], {
    A: 'forbidden_arcanus:obsidian_ingot'
  })

  /*--------------------------Overloaded--------------------------*/
  //Infinite Water Source
  e.shaped(item.of('overloaded:infinite_water_source', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: 'mekanism:ultimate_mechanical_pipe',
    B: 'mekanism:enriched_diamond',
    C: 'cookingforblockheads:sink'
  })
  //Multi-Armor Settings Editor
  e.shaped(item.of('overloaded:settings_editor', 1), [
    'ABB',
    'BCB',
    'BBB'
  ], {
    A: 'eidolon:gold_inlay',
    B: 'extendedcrafting:nether_star_block',
    C: 'overloaded:energy_core'
  })
  //Multi Tool
  e.shaped(item.of('overloaded:multi_tool', 1), [
    'ED ',
    'DCB',
    ' BA'
  ], {
    A: 'compressium:iron_9',
    B: 'extendedcrafting:nether_star_block',
    C: 'overloaded:energy_core',
    D: 'extendedcrafting:ender_star',
    E: 'forbidden_arcanus:dark_nether_star'
  })
  //Railgun
  e.shaped(item.of('overloaded:railgun', 1), [
    '   ',
    'AAB',
    ' AA'
  ], {
    A: 'extendedcrafting:nether_star_block',
    B: 'overloaded:energy_core'
  })
  //Instant Furnace
  e.shaped(item.of('overloaded:instant_furnace', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: 'ironfurnaces:million_furnace',
    B: 'mysticaladaptations:insanium_furnace',
    C: 'overloaded:energy_core'
  })
  /*--------------------------Eidolon--------------------------*/
  //remove
  e.remove({ id: 'eidolon:smelt_stone_brick' })
  //Lead Ingot
  e.shapeless(item.of('eidolon:lead_ingot'), ['thermal:lead_ingot', 'eidolon:enchanted_ash'])
  //Basic Amulet
  e.remove({ id: 'eidolon:basic_amulet' })
  e.shaped(item.of('eidolon:basic_amulet', 1), [
    ' B ',
    'B B',
    ' A '
  ], {
    A: '#forge:ingots/arcane_gold',
    B: 'minecraft:string'
  })
  //Basic Ring
  e.remove({ id: 'eidolon:basic_ring' })
  e.shaped(item.of('eidolon:basic_ring', 1), [
    ' B ',
    'A A',
    ' A '
  ], {
    A: '#forge:ingots/arcane_gold',
    B: 'eidolon:soul_shard'
  })
  //Gold Inlay
  e.remove({ id: 'eidolon:gold_inlay' })
  e.shaped(item.of('eidolon:gold_inlay', 2), [
    ' A ',
    'A A',
    ' A '
  ], {
    A: '#forge:ingots/arcane_gold'
  })
  //Goblet
  e.remove({ id: 'eidolon:goblet' })
  e.shaped(item.of('eidolon:goblet', 1), [
    'A A',
    ' A ',
    ' A '
  ], {
    A: '#forge:ingots/arcane_gold'
  })
  //Ability Bottle
  e.remove({ id: 'everlastingabilities:ability_bottle' })
  e.shaped(item.of('everlastingabilities:ability_bottle', 1), [
    'ABA',
    'CDC',
    'ECE'
  ], {
    A: '#forge:dyes/white',
    B: 'minecraft:slime_ball',
    C: '#forge:plates/gold',
    D: 'minecraft:experience_bottle',
    E: 'minecraft:bucket'
  })

  //Flux Core
  e.remove({ id: 'fluxnetworks:fluxcore' })
  e.shaped(item.of('fluxnetworks:flux_core', 4), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: 'fluxnetworks:flux_dust',
    B: 'ironfurnaces:item_heater',
    C: 'minecraft:ender_eye'
  })

  //CAD Assembleur
  e.remove({ id: 'psi:assembler' })
  e.shaped(item.of('psi:cad_assembler', 1), [
    'BAB',
    'BCB',
    ' B '
  ], {
    A: 'bluepower:project_table',
    B: 'bluepower:tungsten_ingot',
    C: 'eidolon:pewter_ingot'
  })

  //Spell Programmer
  e.remove({ id: 'psi:programmer' })
  e.shaped(item.of('psi:programmer', 1), [
    'BAB',
    'CDC',
    ' C '
  ], {
    A: 'rftoolscontrol:cpu_core_2000',
    B: 'bluepower:tungsten_ingot',
    C: 'eidolon:pewter_ingot',
    D: 'psi:psidust'
  })

  //Gun Powder Block
  e.remove({ id: 'thermal:storage/gunpowder_block' })

  //Rainbow Wool
  e.shaped(item.of('earthmobsmod:rainbow_wool', 1), [
    'ABC',
    'DEF',
    ' G '
  ], {
    A: 'minecraft:red_dye',
    B: 'minecraft:orange_dye',
    C: 'minecraft:yellow_dye',
    D: 'minecraft:lime_dye',
    E: 'minecraft:blue_dye',
    F: 'minecraft:purple_dye',
    G: 'minecraft:white_wool'
  })

  //Other
  //Blank Scanner Module
  e.remove({ id: 'scannable:module_blank' })
  e.shaped(item.of('scannable:module_blank', 1), [
    'AAA',
    'ABA',
    'CDC'
  ], {
    A: 'botania:cell_block',
    B: 'bloodmagic:blankslate',
    C: '#forge:plates/gold',
    D: 'rftoolscontrol:cpu_core_2000'
  })

  //Scanner
  e.remove({ id: 'scannable:scanner' })
  e.shaped(item.of(item.of('scannable:scanner', { energy: 5000 }), 1), [
    'A A',
    'BCB',
    'BDB'
  ], {
    A: 'xnet:antenna',
    B: 'kubejs:platinum_nugget',
    C: 'bluepower:lumar_red',
    D: 'immersiveengineering:circuit_board'
  })

  //Blank Upgrade Module
  e.remove({ id: 'mininggadgets:upgrade_empty' })
  e.shaped(item.of('mininggadgets:upgrade_empty', 1), [
    'ABA',
    'CDC',
    'ABA'
  ], {
    A: 'minecraft:redstone',
    B: 'kubejs:platinum_nugget',
    C: 'botania:mana_diamond',
    D: 'forbidden_arcanus:arcane_glass_pane'
  })

  //Heavy Stone Bricks
  e.remove({ id: 'architects_palette:heavy_stone_bricks' })
  e.shaped(item.of('architects_palette:heavy_stone_bricks', 8), [
    'AAA',
    'A A',
    'AAA'
  ], {
    A: 'minecraft:stone'
  })

  //Sawdust Flooring
  e.remove({ id: 'immersiveengineering:crafting/sawdust' })
  e.shaped(item.of('immersiveengineering:sawdust', 6), [
    '   ',
    'AAA',
    'AAA'
  ], {
    A: 'thermal:sawdust'
  })
  //Weeping Blackstone Bricks
  e.remove({ id: 'architects_palette:weeping_blackstone_bricks' })
  e.shapeless(Item.of('architects_palette:weeping_blackstone_bricks', 4), ['architects_palette:weeping_blackstone', 'architects_palette:weeping_blackstone', 'architects_palette:weeping_blackstone', 'architects_palette:weeping_blackstone'])

  //Twisting Blackstone Bricks
  e.remove({ id: 'architects_palette:twisting_blackstone_bricks' })
  e.shapeless(Item.of('architects_palette:twisting_blackstone_bricks', 4), ['architects_palette:twisting_blackstone', 'architects_palette:twisting_blackstone', 'architects_palette:twisting_blackstone', 'architects_palette:twisting_blackstone'])

  //Warp Dust
  e.remove({ id: 'waystones:warp_dust' })
  e.shapeless(Item.of('waystones:warp_dust'), ['thermal:diamond_dust', '#forge:dyes/purple'])

  //Gold Flower
  e.shaped(item.of('resourcefulbees:gold_flower', 1), [
    'AAA',
    'ABA',
    'AAA'
  ], {
    A: 'minecraft:gold_ingot',
    B: '#botania:double_mystical_flowers'
  })
  //Sheet Metal
  e.remove({ id: 'dustrial_decor:sheet_metal' })
  e.shaped(item.of('dustrial_decor:sheet_metal', 3), [
    '   ',
    'AAA',
    '   '
  ], {
    A: 'thermal:iron_plate'
  })
  /*****************************************SOLAR PANEL*****************************************/
  //Gobber Photovoltaic Cell
  e.shaped(item.of('kubejs:gobber_photovoltaic_cell', 1), [
    'AAA',
    'BCB',
    'DED'
  ], {
    A: 'gobber2:gobber2_ingot_end',
    B: 'minecraft:glowstone',
    C: 'compressium:diamond_1',
    D: '#forge:storage_blocks/quartz',
    E: 'solarflux:photovoltaic_cell_6'
  })

  //Ethernium Photovoltaic Cell
  e.shaped(item.of('kubejs:etherium_photovoltaic_cell', 1), [
    'AAA',
    'BCB',
    'DED'
  ], {
    A: 'enigmaticlegacy:etherium_ingot',
    B: 'minecraft:glowstone',
    C: 'compressium:diamond_2',
    D: '#forge:storage_blocks/quartz',
    E: 'kubejs:gobber_photovoltaic_cell'
  })

  //Ultimate Photovoltaic Cell
  e.shaped(item.of('kubejs:ultimate_photovoltaic_cell', 1), [
    'AAA',
    'BCB',
    'DED'
  ], {
    A: 'extendedcrafting:the_ultimate_ingot',
    B: 'minecraft:glowstone',
    C: 'compressium:diamond_3',
    D: '#forge:storage_blocks/quartz',
    E: 'kubejs:etherium_photovoltaic_cell'
  })
//Void World Blocs
  e.remove({ id: 'javd:portal_block' })
  e.custom(
    {
      "type": "extendedcrafting:shaped_ender_crafter",
      "tier": 1,
      "pattern": ["ABA", "BCB", "ABA"],
      "key": {
        "A": { "item": "farlanders:ender_horn" },
        "B": { "item": "quark:basalt" },
        "C": { "item": "forbidden_arcanus:dark_matter" }
      },
      "result": { "item": "javd:portal_block", "count": 1 }
    }
  )
//Mining World Blocs
  e.remove({ id: 'jamd:mine_portal_block' })
  e.custom(
    {
      "type": "extendedcrafting:shaped_ender_crafter",
      "tier": 1,
      "pattern": ["ABA", "BCB", "ABA"],
      "key": {
        "A": { "item": "farlanders:ender_horn" },
        "B": { "item": "quark:basalt" },
        "C": { "item": "minecraft:netherite_pickaxe" }
      },
      "result": { "item": "jamd:mine_portal_block", "count": 1 }
    }
  )
//Market
  e.remove({ id: 'farmingforblockheads:market' })
  e.custom(
    {
      "type": "create:mechanical_crafting",
      "pattern": [
        "AAAAAAA",
        "BCBBBCB",
        " CDDDC ",
        "EEEFEEE",
        " GGFGG ",
        " GGFGG ",
        " GGGGG "],
      "key": {
        "A": {"item": "immersiveengineering:slab_sheetmetal_steel"},
        "B": {"item": "engineersdecor:halfslab_sheetmetal_steel"},
        "C": {"item": "minecraft:dark_oak_fence"},
        "D": {"item": "farlanders:endumium_crystal"},
        "E": {"item": "minecraft:spruce_planks"},
        "F": {"item": "thermal:red_rockwool"},
        "G": {"item": "minecraft:spruce_wood"}
      },
      "result": {"item": "farmingforblockheads:market","count": 1}
    }
  )
  //Litherite
  e.remove({ id: 'envirocore:items/ct_litherite2' })
  e.remove({ id: 'envirocore:items/ct_litherite4' })
  e.remove({ id: 'envirocore:items/ct_litherite6' })
  e.remove({ id: 'envirocore:items/ct_litherite8' })
  e.custom(
    {
      "type": "tconstruct:casting_basin",
      "cast": {
        "type": "mantle:intersection",
        "ingredients": [
          {
            "item": "powah:uraninite_block"
          }
        ]
      },
      "cast_consumed": true,
      "fluid": {
        "name": "tconstruct:molten_queens_slime",
        "amount": 2880
      },
      "result": "envirocore:litherite",
      "cooling_time": 120
    }
  )
  //Neptunium Ingot
  e.smelting('aquaculture:neptunium_ingot', 'aquaculture:neptunes_bounty')
  //Pied Wool
  e.shaped(item.of('rats:pied_wool', 1), [
    'ABA',
    'BAB',
    'ABA'
  ], {
    A: 'minecraft:light_blue_wool',
    B: 'minecraft:yellow_wool'
  })
  //Cloth Forbidden & Arcanus
  e.remove({ id: 'forbidden_arcanus:cloth' })
  e.shaped(item.of('forbidden_arcanus:cloth', 2), [
    'AAA',
    'ABA',
    'AAA'
  ], {
    A: 'minecraft:string',
    B: 'minecraft:white_wool'
  })
  //Roller (pams)
  e.remove({ id: 'pamhc2foodcore:tool_roller' })
  e.shaped(item.of('pamhc2foodcore:rolleritem', 1), [
    '  A',
    ' B ',
    'A  '
  ], {
    A: '#forge:rods/wooden',
    B: '#minecraft:planks'
  })
  //Vanilla Chests (BYG Planks)
  e.shaped(item.of('minecraft:chest', 1), [
    'AAA',
    'A A',
    'AAA'
  ], {
    A: '#forge:other/planks'
  })
  //Vanilla Chests (BYG logs)
  e.shaped(item.of('minecraft:chest', 4), [
    'AAA',
    'A A',
    'AAA'
  ], {
    A: '#forge:other/logs'
  })
  //Culinary Station
  e.remove({ id: 'culinaryconstruct:culinary_station' })
  e.shaped(item.of('culinaryconstruct:culinary_station', 1), [
    ' A ',
    ' B ',
    '   '
  ], {
    A: '#minecraft:slabs',
    B: '#forge:workbench'
  })
  //Loading Pearl
  e.shaped(item.of('kubejs:loading_pearl', 1), [
    ' A ',
    'ABA',
    ' A '
  ], {
    A: 'waystones:warp_dust',
    B: 'minecraft:ender_pearl'
  })
  //Single Chunk Loader
  e.remove({ id: 'chunknogobyebye:loader' })
  e.shaped(item.of('chunknogobyebye:loader', 1), [
    'AAA',
    'ABA',
    'AAA'
  ], {
    A: '#minecraft:planks',
    B: 'kubejs:loading_pearl'
  })
  //Chaotic Bee Flower
  e.shaped(item.of('kubejs:chaotic_bee_flower', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: '#minecraft:flowers',
    B: 'draconicevolution:chaos_shard',
    C: 'resourcefulbees:wax_block'
  })
  //Dragon Bee Flower
  e.shaped(item.of('kubejs:dragon_bee_flower', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: '#minecraft:flowers',
    B: 'mysticalagradditions:dragon_scale',
    C: 'resourcefulbees:wax_block'
  })
  //Trapped Chest Vanilla
  e.shapeless(item.of('minecraft:trapped_chest'), ['minecraft:chest', 'minecraft:tripwire_hook'])
  //Heavy End Stone Bricks
  e.remove({ id: 'architects_palette:heavy_end_stone_bricks' })
  e.shapeless(item.of('architects_palette:heavy_end_stone_bricks'), ['minecraft:end_stone_bricks', 'minecraft:end_stone_bricks', 'minecraft:end_stone_bricks', 'minecraft:end_stone_bricks', 'minecraft:end_stone_bricks', 'minecraft:end_stone_bricks', 'minecraft:end_stone_bricks', 'minecraft:end_stone_bricks', 'minecraft:end_stone_bricks'])
  //Smithing Machine Block
  e.shapeless(item.of('kubejs:smithing_machine_block'), ['minecraft:smithing_table'])
  //slag  
  e.shapeless(item.of('thermal:slag'), ['immersiveengineering:slag'])
  //Lattice (decorative block)
  e.remove({ id: 'decorative_blocks:lattice' })
  e.shaped(item.of('decorative_blocks:lattice', 1), [' A ', 'AAA', ' A '], {
    A: '#forge:rods/wooden'
  })
  //Sleeping Bag
  function sleepingbag(color){
    e.remove({id: 'comforts:sleeping_bag_'+color+''})
    e.shaped(item.of('comforts:sleeping_bag_'+color+'', 1), ['   ','AAA','   '], {A: 'amb:'+color+'_wool_slab'})
  }
  var color = ["red", "orange", "yellow", "lime", "green", "blue", "cyan", "light_blue", "pink", "magenta", "purple", "brown", "black", "gray", "light_gray", "white"]
  color.forEach(C => { sleepingbag(C) })

  //Corundum
  function corundum(color){
    e.shaped(item.of('quark:'+ color +'_crystal', 1), ['AA ','AA ','   '], {A: "quark:"+ color +"_crystal_cluster"})
  }
  var crystalColor = ["red", "orange", "yellow", "green", "blue", "indigo", "violet", "white", "black"]
  crystalColor.forEach(C => { corundum(C) })

  //Cobbled Deepslate
  e.custom({"type":"create:crushing","ingredients": [{"item": 'quark:deepslate'}],"results": [{"item": 'quark:cobbled_deepslate'}],"processingTime": 350})
  e.custom({"type": "thermal:pulverizer","ingredient": {"item": 'quark:deepslate'},"result": [{"item": 'quark:cobbled_deepslate',"count": 1}],"energy_mod": 0.5})
  e.custom({"type":"mekanism:crushing","input":{"ingredient":{"item":'quark:deepslate'}},"output":{"item":'quark:cobbled_deepslate'}})

  //Krabby Patty
  e.shapeless(item.of('jellyfishing:krabby_patty'), ['pamhc2foodcore:skilletitem', 'minecraft:bread', 'jellyfishing:jellyfish_jelly', 'pamhc2crops:tomatoitem', 'rats:cheese', 'pamhc2crops:lettuceitem', 'pamhc2foodcore:groundbeefitem', 'pamhc2foodextended:ketchupitem', 'pamhc2crops:onionitem'])
  //Wither Bones
  e.shapeless(item.of('tconstruct:necrotic_bone'), ['iceandfire:witherbone'])
  e.shapeless(item.of('tconstruct:necrotic_bone'), ['bhc:wither_bone'])
  e.shapeless(item.of('tconstruct:necrotic_bone'), ['architects_palette:withered_bone'])
  
  //Concealment Key
  e.shapeless(item.of('storagedrawers:shroud_key'), ['storagedrawers:drawer_key', 'minecraft:ender_eye'])

  //Smooth Purpur Block
  e.remove({ id: 'amb:smooth_purpur_block' })
  e.shapeless(item.of('amb:smooth_purpur_block', 4), ['minecraft:purpur_block', 'minecraft:purpur_block', 'minecraft:purpur_block', 'minecraft:purpur_block'])

  //Iron plate / Rusty iron plate
  e.remove({ id: 'quark:building/crafting/rusty_iron_plate2' })
  e.remove({ id: 'quark:building/crafting/rusty_iron_plate' })
  e.shaped(item.of('quark:rusty_iron_plate', 24), ['AAA', 'ABA', 'AAA'], {
    A: 'dustrial_decor:rusty_iron_ingot',
    B: 'minecraft:water_bucket'
  })
  //singularity Tank
  e.remove({ id: 'mob_grinding_utils:recipe_tank' })
  e.shaped(item.of('mob_grinding_utils:tank'), ['ABA', 'BBB', 'ABA'], {
    A: 'mekanism:basic_fluid_tank',
    B: '#forge:glass'
  })
//Red Alloy Ingot
  e.custom({
    "type": "thermal:smelter",
    "input": [
      { "item": "thermal:copper_ingot" },
      { "item": "minecraft:redstone", "count": 4 }
    ],
    "result": [{ "item": "bluepower:red_alloy_ingot", "count": 1 }],
    "energy": 1600
  })
  //Blue Alloy Ingot
  e.custom({
    "type": "thermal:smelter",
    "input": [
      { "item": "thermal:copper_ingot" },
      { "item": "janoeo:sapphire_dust", "count": 4 }
    ],
    "result": [{ "item": "bluepower:blue_alloy_ingot", "count": 1 }],
    "energy": 1600
  })
//PIPEZ
//Universal
e.remove({id: "pipez:universal_pipe"})
e.shaped(item.of('pipez:universal_pipe', 8), [
  'ABC',
  'DED',
  'CBA'
], {
  A: 'pipez:item_pipe',
  B: 'pipez:energy_pipe',
  C: 'pipez:fluid_pipe',
  D: 'pipez:gas_pipe',
  E: 'minecraft:redstone_block'
})
//XNET
//Red connector
e.remove({id: "xnet:connector_red"})
e.shaped(item.of('xnet:connector_red', 1), [
  'ABA',
  'CDC',
  'ACA'
], {
  A: '#forge:dyes/red',
  B: 'pipez:universal_pipe',
  C: 'minecraft:redstone',
  D: 'minecraft:diamond'
})
//Green connector
e.remove({id: "xnet:connector_green"})
e.shaped(item.of('xnet:connector_green', 1), [
  'ABA',
  'CDC',
  'ACA'
], {
  A: '#forge:dyes/green',
  B: 'pipez:universal_pipe',
  C: 'minecraft:redstone',
  D: 'minecraft:diamond'
})
//Blue connector
e.remove({id: "xnet:connector_blue"})
e.shaped(item.of('xnet:connector_blue', 1), [
  'ABA',
  'CDC',
  'ACA'
], {
  A: '#forge:dyes/blue',
  B: 'pipez:universal_pipe',
  C: 'minecraft:redstone',
  D: 'minecraft:diamond'
})
//Yellow connector
e.remove({id: "xnet:connector_yellow"})
e.shaped(item.of('xnet:connector_yellow', 1), [
  'ABA',
  'CDC',
  'ACA'
], {
  A: '#forge:dyes/yellow',
  B: 'pipez:universal_pipe',
  C: 'minecraft:redstone',
  D: 'minecraft:diamond'
})
//Jail Door
e.remove({id: "mcwdoors:jail_door"})
e.shaped(item.of('mcwdoors:jail_door', 1), [
  'AA ',
  'AA ',
  'AA '
], {
  A: 'createaddition:iron_rod'
})
//Glass Trapdor
e.remove({id: "upgrade_aquatic:glass_trapdoor"})
e.shaped(item.of('upgrade_aquatic:glass_trapdoor', 1), [
  '   ',
  '   ',
  'AA '
], {
  A: 'minecraft:glass'
})
//External Heater
e.remove({id: "immersiveengineering:crafting/furnace_heater"})
e.shaped(item.of('immersiveengineering:furnace_heater', 1), [
  'ABA',
  'BCB',
  'ADA'
], {
  A: 'minecraft:iron_ingot',
  B: 'thermal:copper_ingot',
  C: 'immersiveengineering:coil_lv',
  D: 'minecraft:redstone'
})
//Jar (Ice and Fire)
e.remove({id: "iceandfire:jar_empty"})
e.shaped(item.of('iceandfire:pixie_jar_empty', 1), [
  'ABA',
  'A A',
  'AAA'
], {
  A: '#forge:glass',
  B: '#minecraft:wooden_pressure_plates'
})
//Jar supplementaries
e.remove({id: "supplementaries:jar"})
e.shaped(item.of('supplementaries:jar', 1), [
  'ABA',
  'A A',
  'AAA'
], {
  A: '#forge:glass',
  B: '#minecraft:wooden_slabs'
})
//Jar tinted supplementaries
e.remove({id: "supplementaries:jar_tinted"})
e.shaped(item.of('supplementaries:jar_tinted', 1), [
  'ABA',
  'A A',
  'AAA'
], {
  A: 'mob_grinding_utils:tinted_glass',
  B: '#minecraft:wooden_slabs'
})
//Waxed Block of Fiery Metal
e.shaped(item.of('kubejs:waxed_fiery_block', 1), [
  'AAA',
  'ABA',
  'AAA'
], {
  A: 'resourcefulbees:icy_honeycomb',
  B: 'twilightforest:fiery_block'
})

//Ender Pearl Block (Architect's Palette)
e.remove({id: "architects_palette:ender_pearl_block"})
e.shaped(item.of('architects_palette:ender_pearl_block', 1), ['AAA','AAA','AAA'], {
  A: 'minecraft:ender_pearl'
})
e.remove({id: "architects_palette:ender_pearl_from_block"})
e.shapeless(Item.of('minecraft:ender_pearl', 9), 'architects_palette:ender_pearl_block')


//Corn on the Cob (Pam's)
e.remove({id: "pamhc2foodextended:cornonthecobitem"})
e.shaped(item.of('pamhc2foodextended:cornonthecobitem', 1), [
  'ABB',
  'CD ',
  '   '
], {
  A: 'pamhc2foodcore:potitem',
  B: '#forge:crops/corn',
  C: '#forge:butter',
  D: '#forge:salt'
})

//Mushroom Spores
e.remove({id: 'extendedmushrooms:mushroom_spores'})
e.custom({"type": "thermal:pulverizer","ingredient": {"tag": 'forge:mushrooms'},"result": [{"item": 'extendedmushrooms:mushroom_spores',"chance": 2.0},{"item": 'extendedmushrooms:mushroom_spores',"chance": 0.1},{"item": "minecraft:gravel","chance": 0.2}],"experience": 0.2,})

//Flour Pams
e.remove({id: "pamhc2foodcore:flour_x1_flour_plants"})
e.shapeless(Item.of('pamhc2foodcore:flouritem', 1), ['pamhc2foodcore:grinderitem', 'minecraft:wheat'])


//Draconium Ingot
e.custom({
  "type": "create:sequenced_assembly",
  "ingredient": {"tag": "forge:ingots/manyullyn"},
  "transitionalItem": {"item": "tconstruct:manyullyn_ingot"},
  "sequence": [
    {"type": "create:deploying",
     "ingredients": [{"item": "tconstruct:manyullyn_ingot"},{"item": "draconicevolution:draconium_dust"}],
     "results": [{"item": "kubejs:incomplete_draconium"}]},
    {"type": "create:deploying",
     "ingredients": [{"item": "tconstruct:manyullyn_ingot"},{"item": "mysticalagradditions:creative_essence"}],
     "results": [{"item": "kubejs:incomplete_draconium"}]},
    {"type": "create:deploying",
     "ingredients": [{"item": "tconstruct:manyullyn_ingot"},{"item": "envirocore:nanorite_crystal"}],
     "results": [{"item": "kubejs:incomplete_draconium"}]}],
     "results": [{"item": "draconicevolution:draconium_ingot","chance": 80.0},
              {"item": "mysticalagradditions:creative_essence","chance": 15.0},
              {"item": "tconstruct:manyullyn_ingot","chance": 1.0},
              {"item": "draconicevolution:draconium_dust","chance": 1.0},
              {"item": "envirocore:nanorite_crystal","chance": 1.0},
              {"item": "draconicevolution:draconium_nugget","chance": 1.0},
              {"item": "tconstruct:manyullyn_nugget","chance": 1.0}],"loops": 4})
//Lavasponge
e.remove({id: "lavasponge:lavasponge"})
e.smoking('lavasponge:lavasponge', 'minecraft:sponge')
//Miniature Twilight Portal
e.shaped(item.of('twilightforest:twilight_portal_miniature_structure', 1), [
  'ABC',
  'D E',
  'FGH'
], {
  A: 'twilightforest:naga_trophy',
  B: 'twilightforest:lich_trophy',
  C: 'twilightforest:minoshroom_trophy',
  D: 'twilightforest:hydra_trophy',
  E: 'twilightforest:knight_phantom_trophy',
  F: 'twilightforest:ur_ghast_trophy',
  G: 'twilightforest:yeti_trophy',
  H: 'twilightforest:snow_queen_trophy'
})

//Copper Barrel
  e.remove({ id: 'metalbarrels:barrels/wood_to_copper_barrel' })
  e.shaped(item.of('metalbarrels:copper_barrel', 1), [
    'AAA',
    'ABA',
    'AAA'
  ], {
    A: 'thermal:copper_ingot',
    B: '#forge:barrels/wooden'
  })
//Iron Barrel
  e.remove({ id: 'metalbarrels:barrels/copper_to_iron_barrel' })
  e.shaped(item.of('metalbarrels:iron_barrel', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: 'minecraft:iron_ingot',
    B: '#forge:glass',
    C: 'metalbarrels:copper_barrel'
  })
//Silver Barrel
  e.remove({ id: 'metalbarrels:barrels/iron_to_silver_barrel' })
  e.shaped(item.of('metalbarrels:silver_barrel', 1), [
    'AAA',
    'BCB',
    'AAA'
  ], {
    A: '#forge:glass',
    B: 'thermal:silver_ingot',
    C: 'metalbarrels:iron_barrel'
  })
//Gold Barrel
  e.remove({ id: 'metalbarrels:barrels/silver_to_gold_barrel' })
  e.shaped(item.of('metalbarrels:gold_barrel', 1), [
    'ABA',
    'BCB',
    'ABA'
  ], {
    A: 'minecraft:gold_ingot',
    B: '#forge:glass',
    C: 'metalbarrels:silver_barrel'
  })
//Diamond Barrel
  e.remove({ id: 'metalbarrels:barrels/gold_to_diamond_barrel' })
  e.shaped(item.of('metalbarrels:diamond_barrel', 1), [
    'AAA',
    'BCB',
    'AAA'
  ], {
    A: '#forge:glass',
    B: 'minecraft:diamond',
    C: 'metalbarrels:gold_barrel'
  })
//Obsidian Barrel
  e.remove({ id: 'metalbarrels:barrels/diamond_to_obsidian_barrel' })
  e.shaped(item.of('metalbarrels:obsidian_barrel', 1), [
    'AAA',
    'ABA',
    'AAA'
  ], {
    A: 'minecraft:obsidian',
    B: 'metalbarrels:diamond_barrel'
  })
//Crystal Barrel
  e.remove({ id: 'metalbarrels:barrels/diamond_to_crystal_barrel' })
  e.shaped(item.of('metalbarrels:crystal_barrel', 1), [
    'AAA',
    'ABA',
    'AAA'
  ], {
    A: '#forge:glass',
    B: 'metalbarrels:diamond_barrel'
  })
//Item Box (Sonic)
  e.remove({ id: 'sonicraft:item_box_recipe' })
  e.shaped(item.of('sonicraft:item_box', 1), [
    'AAA',
    'ABA',
    'CCC'
  ], {
    A: 'minecraft:iron_ingot',
    B: 'sonicraft:gold_ring',
    C: 'minecraft:iron_nugget'
  })

//Environmental Energy
//Litherite Solar
e.remove({ id: 'enviroenergy:block/solar/litherite' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:litherite_crystal" },
      "B": { "item": "enviroenergy:litherite_solar_cell" },
      "C": { "tag": "envirocore:structure/panels" }
    },
    "result": { "item": "enviroenergy:litherite_solar_ccu", "count": 1 }
  }
)
//Erodium Solar
e.remove({ id: 'enviroenergy:block/solar/erodium' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:erodium_crystal" },
      "B": { "item": "enviroenergy:erodium_solar_cell" },
      "C": { "item": "enviroenergy:litherite_solar_ccu" }
    },
    "result": { "item": "enviroenergy:erodium_solar_ccu", "count": 1 }
  }
)
//Kyronite Solar
e.remove({ id: 'enviroenergy:block/solar/kyronite' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:kyronite_crystal" },
      "B": { "item": "enviroenergy:kyronite_solar_cell" },
      "C": { "item": "enviroenergy:erodium_solar_ccu" }
    },
    "result": { "item": "enviroenergy:kyronite_solar_ccu", "count": 1 }
  }
)
//Pladium Solar
e.remove({ id: 'enviroenergy:block/solar/pladium' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:pladium_crystal" },
      "B": { "item": "enviroenergy:pladium_solar_cell" },
      "C": { "item": "enviroenergy:kyronite_solar_ccu" }
    },
    "result": { "item": "enviroenergy:pladium_solar_ccu", "count": 1 }
  }
)
//Ionite Solar
e.remove({ id: 'enviroenergy:block/solar/ionite' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:ionite_crystal" },
      "B": { "item": "enviroenergy:ionite_solar_cell" },
      "C": { "item": "enviroenergy:pladium_solar_ccu" }
    },
    "result": { "item": "enviroenergy:ionite_solar_ccu", "count": 1 }
  }
)
//Aethium Solar
e.remove({ id: 'enviroenergy:block/solar/aethium' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:aethium_crystal" },
      "B": { "item": "enviroenergy:aethium_solar_cell" },
      "C": { "item": "enviroenergy:ionite_solar_ccu" }
    },
    "result": { "item": "enviroenergy:aethium_solar_ccu", "count": 1 }
  }
)
//Nanorite Solar
e.remove({ id: 'enviroenergy:block/solar/nanorite' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:nanorite_crystal" },
      "B": { "item": "enviroenergy:nanorite_solar_cell" },
      "C": { "item": "enviroenergy:aethium_solar_ccu" }
    },
    "result": { "item": "enviroenergy:nanorite_solar_ccu", "count": 1 }
  }
)
//Xerothium Solar
e.remove({ id: 'enviroenergy:block/solar/xerothium' })
e.custom(
  {
    "type": "extendedcrafting:shaped_table",
    "tier": 1,
    "pattern": ["ABA", "BCB", "ABA"],
    "key": {
      "A": { "item": "envirocore:xerothium_crystal" },
      "B": { "item": "enviroenergy:xerothium_solar_cell" },
      "C": { "item": "enviroenergy:nanorite_solar_ccu" }
    },
    "result": { "item": "enviroenergy:xerothium_solar_ccu", "count": 1 }
  }
)

//Rusty Iron Plate
e.custom({"type": "thermal:bottler","ingredient": [{"item": "quark:iron_plate"},{"fluid": "minecraft:water","amount": 125}],"result": [{"item": "quark:rusty_iron_plate"}]})
//Treated Wood
e.custom({"type": "thermal:bottler","ingredient": [{"tag": "minecraft:planks"},{"fluid": "thermal:creosote" ,"amount": 125}],"result": [{"item": "immersiveengineering:treated_wood_horizontal"}]})
e.custom({"type": "thermal:bottler","ingredient": [{"tag": "minecraft:planks"},{"fluid": "immersiveengineering:creosote" ,"amount": 125}],"result": [{"item": "immersiveengineering:treated_wood_horizontal"}]})
//Bitumen block
e.remove({ id: 'mapperbase:bitumen_block' })
e.remove({ id: 'mapperbase:raw_bitumen_from_block' })
e.shapeless(item.of('thermal:bitumen', 4), ['mapperbase:bitumen_block'])
e.shapeless('mapperbase:bitumen_block', [item.of('thermal:bitumen', 4)])
//Rotten Flesh Block (Architect's Palette)
  e.remove({ id: 'architects_palette:rotten_flesh_block' })
  e.remove({ id: 'architects_palette:rotten_flesh' })
e.shapeless(item.of('minecraft:rotten_flesh', 4), ['architects_palette:rotten_flesh_block'])
e.shapeless('architects_palette:rotten_flesh_block', [item.of('minecraft:rotten_flesh', 4)])
})